'SNH Interpreter.bas for SmallBASIC 0.12.9 (B+=MGA) 2017-07-31
' Strings Now Handled
CONST  CHARWIDTH = TXTW("W")
CONST  CELLSPERLINE = XMAX/CHARWIDTH
memsize = 20000
DIM m$(memsize)
numChars = "-.1234567890"
cmdChars = "W?ABCDFMIENP[X]%^/*~+=<>()!&|"
allChars = numChars + cmdChars

WHILE 1
  CLS
  anyfile = FILES("*SNH.txt")
  ? "SNH (Strings Now Handled) Files:":?
  IF LEN(anyfile) > 0 THEN
    FOR i = 0 TO ubound(anyfile)
      ? i, anyfile(i)
    NEXT
    ? : INPUT "number > files quits, Enter file NUMBER to run (any else quits) > ", flnm
    IF ISNUMBER(flnm) AND flnm >= 0 AND flnm <= UBOUND(anyfile)
        getfile = anyfile(flnm)
        TLOAD getfile, source, 1
        CLS : runSource
    ELSE
      STOP
    END IF
  ELSE
    ? "Sorry, no files to run, press any..." : STOP
  END IF
WEND

SUB runSource  'NOTE watch out for locals!
  ERASE m$
  DIM m$(memsize)
  'note: anything above first {} 
  bs = INSTR(source, "{") : be = INSTR(bs + 1, source, "}")
  WHILE bs AND be
    ix = VAL(MID(source, bs + 1, be - bs - 1)) 
    IF ix < 1 THEN EXIT LOOP
    bs = INSTR(be + 1, source, "{")
    ti = MID(source, be + 1, bs - be - 1)
    tEnd = INSTR(ti, ";")
    IF tEnd = 0 THEN ? "Missing ; for {";ix;"}." : PAUSE : EXIT SUB
    ti = MID(ti, 1, tEnd - 1)
    m$(ix) = ti
    be = INSTR(bs + 1, source, "}")
    IF be = 0 THEN ? "Unmatched { } pairs." : PAUSE : EXIT SUB 
  WEND
  source = MID(source, be + 1)
  
  source = UCASE(source)
  '? "Source after {}:"
  
  'let's clean the code up, check bracket balance
  bktCnt = 0 : ifCnt = 0 : code = ""
  FOR i = 1 TO LEN(source)
    char = MID(source, i, 1)
    'check to see if this is a valid instruction character
    IF INSTR(allChars, char) THEN
      code = code + char
      'count brackets
      IF char = "[" THEN bktCnt = bktCnt + 1
      IF char = "]" THEN bktCnt = bktCnt - 1
      if char = "I" Then ifCnt = ifCnt + 1
      if char = "N" then ifCnt = ifCnt - 1
    END IF
  NEXT
  IF bktCnt THEN 'mismatched brackets
    ? "Uneven brackets" : PAUSE : EXIT SUB
  ELSEIF ifCnt THEN
    ? "Uneven I N counts" : PAUSE : EXIT SUB
  ELSE
    '? code  'check
  END IF
  cmd = "" : ds = "" : err = ""
  FOR i = 1 TO LEN(code) 'loop through the code
    c = MID(code, i, 1) 'get the instruction we're on
    IF INSTR("-.1234567890", c) THEN ds = ds + c
    IF INSTR(cmdChars, c) OR i = len(code) THEN 'hit next command or end
      IF cmd <> "" THEN 'execute unfinished command
        d = VAL(ds)
        'exec last cmd
        SELECT CASE cmd
        CASE "A" : m$(1) = m$(d)
        CASE "B" : m$(2) = m$(d)
        CASE "C" : m$(3) = m$(d)
        CASE "D" : m$(4) = m$(d)       
        CASE "F"
          SELECT CASE m$(1) 'the function name m$(2) 1st para...
          CASE "NOT" : IF VAL(m$(2)) <> 0 THEN m$(d) = "0" ELSE m$(d) = "1" 
          CASE "RND" : m$(d) = STR(RND)
          CASE "INT" : m$(d) = STR(INT(VAL(m$(2))))                            
          CASE "CTR": spacesNeeded = (CELLSPERLINE - LEN(m$(2)))/2
            ? SPACE(spacesNeeded) + m$(2);
          CASE "CLS": CLS
          CASE "COLOR": COLOR VAL(m$(2)), VAL(m$(3))
          CASE "LEN": m$(d) = STR(LEN(m$(2)))
          CASE "MID1": m$(d) = MID(m$(2), VAL(m$(3)))
          CASE "MID2": m$(d) = MID(m$(2), VAL(m$(3)), VAL(m$(4)))
          CASE "INSTR1": m$(d) = STR(INSTR(m$(2), m$(3)))
          CASE "INSTR2": m$(d) = STR(INSTR(VAL(m$(2)), m$(3), m$(4)))
          CASE "LOCATE": LOCATE VAL(m$(2)), VAL(m$(3))
          END SELECT
        CASE "M" : m$(d) = m$(0)
        CASE "W" : ? m$(d);
        CASE "?" : INPUT test
          IF ISNUMBER(test) THEN test = STR(test)
          m$(d) = test
        END SELECT
        cmd = "" : ds = ""
      END IF 'if cmd <> ""

      'handle current cmd
      IF INSTR("ABCDFMW?", c) THEN  'get d first
        cmd = c
      ELSEIF c = "I" : IF m$(0) = 0 then Findi
         IF err <> "" THEN ? err : PAUSE : EXIT SUB
      ELSEIF c = "E" THEN
        Findi
        IF err <> "" THEN ? err : PAUSE : EXIT SUB
      ELSEIF c = "P" THEN
        ? 
      ELSEIF c = "X" THEN
        bktCnt = 1 'count the bracket we're on
        i = i + 1 'move the code pointer to the next char
        WHILE bktCnt <> 0
          'count nested loops till we find the matching one
          IF MID(code, i, 1) = "]" THEN bktCnt = bktCnt - 1
          IF MID(code, i, 1) = "[" THEN bktCnt = bktCnt + 1
          i = i + 1 'search forward
        WEND
        i = i - 1
      ELSEIF c = "]" THEN ' end a loop if loop index is 0
        bktCnt = -1 'count the bracket we're on
        i = i - 1   'move the code pointer back a char
        WHILE bktCnt <> 0
          'count nested loops till we fine the matching one
          IF MID(code, i, 1) = "]" THEN bktCnt = bktCnt - 1
          IF MID(code, i, 1) = "[" THEN bktCnt = bktCnt + 1
          i = i - 1 'search backwards
        WEND
        i = i + 1   
      ELSEIF c = "%" THEN : m$(0) = STR(VAL(m$(1)) % VAL(m$(2)))
      ELSEIF c = "^" THEN : m$(0) = STR(VAL(m$(1)) ^ Val(m$(2)))
      ELSEIF c = "/" THEN : m$(0) = STR(VAL(m$(1)) / VAL(m$(2)))
      ELSEIF c = "*" THEN : m$(0) = STR(VAL(m$(1)) * VAL(m$(2)))
      ELSEIF c = "~" THEN : m$(0) = STR(VAL(m$(1)) - VAL(m$(2)))
      ELSEIF c = "+" THEN : m$(0) = STR(VAL(m$(1)) + VAL(m$(2)))
      ELSEIF c = "=" THEN : m$(0) = STR(VAL(m$(1)) = VAL(m$(2)))
      ELSEIF c = "<" THEN : m$(0) = STR(VAL(m$(1)) < VAL(m$(2)))
      ELSEIF c = ">" THEN : m$(0) = STR(VAL(m$(1)) > VAL(m$(2)))
      ELSEIF c = "(" THEN : m$(0) = STR(VAL(m$(1)) <= VAL(m$(2)))
      ELSEIF c = ")" THEN : m$(0) = STR(VAL(m$(1)) >= VAL(m$(2)))
      ELSEIF c = "!" THEN : m$(0) = STR(VAL(m$(1)) <> VAL(m$(2)))
      ELSEIF c = "&" THEN : m$(0) = STR(VAL(m$(1)) AND VAL(m$(2)))
      ELSEIF c = "|" THEN : m$(0) = STR(VAL(m$(1)) OR VAL(m$(2))) 
      END IF
    END IF ' ran into next command
    '? mid(code, i, 1); :input temp
  NEXT
  ?:? "Run is done, hit any..." : PAUSE
END SUB

SUB Findi
  'code, i, err  are global
  LOCAL cnt, c1, j
  cnt = 1
  FOR j = i + 1 TO LEN(code)
    c1 = MID(code, j, 1)
    IF c1 = "N" THEN
      cnt = cnt - 1
      IF cnt = 0 THEN i = j  : EXIT SUB
    ELSEIF c1 = "I" THEN
      cnt = cnt + 1
    ELSEIF c1 = "E" and cnt = 1 THEN
      i = j  : EXIT SUB
    END IF
  NEXT
  err = "Could not find N"
END SUB